\documentclass[11pt]{article}
\usepackage[utf8]{inputenc}
\usepackage[italian]{babel}
\usepackage[a2paper,landscape,top=2cm,bottom=2cm,left=2cm,right=2cm]{geometry}
\usepackage{color}
\usepackage{multirow}

\definecolor{dark-gray}{gray}{0.25}

\newtoks\Fatal
\Fatal{\textcolor{red}{Fatal error}}
\newtoks\Error
\Error{\textcolor{red}{Error}}
\newtoks\Warning
\Warning{\textcolor{yellow}{Warning}}
\newtoks\Ignore
\Ignore{\textcolor{dark-gray}{Ignored}}

\begin{document}

\pagestyle{empty}

\begin{table}
\begin{center}
\begin{tabular}{|l||c|c|}
\hline
\multirow{2}{*}{\textbf{Incoming message}} & \multicolumn{2}{|c|}{\textbf{Current socket state}} \\
\cline{2-3}
	& \textbf{Playing} & \textbf{Awaiting Move} \\
\hline
\hline
\texttt{<move/>} & append to \texttt{\_buffer} & emit receivedMove() + changeState(Playing) \\
\hline
\texttt{<chatMessage/>} & emit receivedChatMessage() & emit receivedChatMessage() \\
\hline
\end{tabular}
\caption{\texttt{StreamSocket} protocol table (both sides)}
\end{center}
\end{table}

\begin{table}
\begin{center}
\begin{tabular}{|l||*{11}{c|}}
\hline
\multirow{2}{*}{\textbf{Incoming message}} & \multicolumn{11}{|c|}{\textbf{Current socket state}} \\
\cline{2-12}
	& \textbf{Unconnected} & \textbf{Connecting} & \textbf{Opening Stream} & \textbf{Fully Opened} & \textbf{Idle} & \textbf{Awaiting Join Answer} & \textbf{Awaiting Game Start} & \textbf{Playing} & \textbf{Awaiting Move} & \textbf{Closing} & \textbf{Closed} \\
\hline
\hline
\texttt{<stream>} \textit{(begin)} & \the\Ignore & \the\Ignore & changeState(FullyOpened$|$Closing) & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{</stream>} \textit{(end)} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Error & \the\Error & \the\Error & \the\Error & \the\Error & \the\Error & changeState(Closed) & \the\Ignore \\
\hline
\texttt{<settings/>} & \the\Ignore & \the\Ignore & \the\Ignore & emit receivedGameSettings() + changeState(Idle) & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<playerJoined/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit playerJoined() & emit playerJoined() & emit playerJoined() & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<playerLeft/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit playerLeft() & emit playerLeft() & emit playerLeft() & \the\Error & \the\Error & \the\Ignore & \the\Ignore \\
\hline
\texttt{<joinRequest/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<joinACK/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit joinAccepted() + changeState(AwaitingGameStart) & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<joinNAK/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit JoinRefused() + changeState(Idle) & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<startGame/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & changeState(Playing) & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<history/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit receivedHistory() & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\end{tabular}
\caption{Client-side protocol table}
\end{center}
\end{table}

\begin{table}
\begin{center}
\begin{tabular}{|l||*{11}{c|}}
\hline
\multirow{2}{*}{\textbf{Incoming message}} & \multicolumn{11}{|c|}{\textbf{Current socket state}} \\
\cline{2-12}
	& \textbf{Unconnected} & \textbf{Listening} & \textbf{Connected} & \textbf{Opening Stream} & \textbf{Fully Opened} & \textbf{Awaiting Join Request} & \textbf{Awaiting Players} & \textbf{Playing} & \textbf{Awaiting Move} & \textbf{Closing} & \textbf{Closed} \\
\hline
\hline
\texttt{<stream>} \textit{(begin)} & \the\Ignore & \the\Ignore & changeState(FullyOpened$|$Closing) & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{</stream>} \textit{(end)} & \the\Ignore & \the\Ignore & \the\Ignore & changeState(Closed) & changeState(Closed) & changeState(Closed) & emit playerLeft() + changeState(Closed) & emit playerLeft() + \the\Error & emit playerLeft() + \the\Error & changeState(Closed) & \the\Ignore \\
\hline
\texttt{<settings/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<playerJoined/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit playerJoined() & emit playerJoined() & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<playerLeft/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit playerLeft() & emit playerLeft() & \the\Error & \the\Error & \the\Ignore & \the\Ignore \\
\hline
\texttt{<joinRequest/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & emit joinRequested() & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<joinACK/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<joinNAK/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<startGame/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\texttt{<history/>} & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore & \the\Ignore \\
\hline
\end{tabular}
\caption{Server-side protocol table}
\end{center}
\end{table}

\end{document}
